package gr.cite.annotation.integrationevent.outbox;

import org.springframework.boot.context.properties.ConfigurationProperties;

@ConfigurationProperties(prefix = "queue.task.publisher.options")
public class OutboxProperties {

    private final String exchange;

    private final String tenantTouchTopic;

    private final String tenantRemovalTopic;

    private final String userTouchTopic;

    private final String userRemovalTopic;

    private final String notifyTopic;

    public OutboxProperties(String exchange,
                            String tenantTouchTopic,
                            String tenantRemovalTopic,
                            String userTouchTopic,
                            String userRemovalTopic,
                            String notifyTopic
    ) {
        this.exchange = exchange;
        this.tenantTouchTopic = tenantTouchTopic;
        this.tenantRemovalTopic = tenantRemovalTopic;
        this.userTouchTopic = userTouchTopic;
        this.userRemovalTopic = userRemovalTopic;
        this.notifyTopic = notifyTopic;
    }

    public String getExchange() {
        return exchange;
    }

    public String getTenantTouchTopic() {
        return tenantTouchTopic;
    }

    public String getTenantRemovalTopic() {
        return tenantRemovalTopic;
    }

    public String getUserTouchTopic() {
        return userTouchTopic;
    }

    public String getUserRemovalTopic() {
        return userRemovalTopic;
    }

    public String getNotifyTopic() {
        return notifyTopic;
    }
}
